//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "USniffThrd.h"
#pragma package(smart_init)


extern unsigned long LocalAddrs[10];
extern unsigned long LocalMasks[10];
//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall TSniffThrd::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall TSniffThrd::TSniffThrd(bool CreateSuspended)
        : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall TSniffThrd::Execute()
{
        FreeOnTerminate = true;
        SOCKET sock;
        SOCKADDR_IN saddr;
        u_long flags;
        BYTE buf[MAX_PACKET_SIZE];
        int cnt;
        tcp_hdr tcp;
        udp_hdr udp;
        ip_hdr ip;
        char caddr[128];
        protoent *pe;
        servent *se;
        pe = new protoent;
        se = new servent;

        sock = socket (PF_INET,SOCK_RAW,IPPROTO_IP);
        ZeroMemory(&saddr,sizeof(saddr));
        saddr.sin_family = AF_INET;

        saddr.sin_family = AF_INET;
        if (FAdaptCase->ListBox1->ItemIndex == FAdaptCase->ListBox1->Items->Count - 1)
        {
                saddr.sin_addr.S_un.S_addr = INADDR_ANY;
        }
        else
        {
                saddr.sin_addr.S_un.S_addr = LocalAddrs[FAdaptCase->ListBox1->ItemIndex];
        }

        bind(sock,(SOCKADDR*)&saddr,sizeof(SOCKADDR));
        flags = 1;
        ioctlsocket(sock,SIO_RCVALL,&flags);

        while (true)
        {
                if (Terminated) break;
                cnt = recv(sock,buf,sizeof(buf),0);
                if (Terminated) break;
                if (cnt>=sizeof(ip_hdr))
                {

                        if (!CheckFilter(buf)) continue;
                       // lenght[index_ar] = (lenght[index_ar]+cnt )/2;
                //        count[index_ar]++;



                        FMain->SGStat->Cells[5][FMain->SGStat->RowCount-1] = IntToStr(cnt);
                        memcpy(&ip,buf,sizeof(ip));
                        saddr.sin_addr.S_un.S_addr = ip.sender;
                        FMain->SGStat->Cells[0][FMain->SGStat->RowCount-1] = inet_ntoa(saddr.sin_addr);
                        saddr.sin_addr.S_un.S_addr = ip.receiver;
                        FMain->SGStat->Cells[1][FMain->SGStat->RowCount-1] = inet_ntoa(saddr.sin_addr);
                        pe = getprotobynumber(ip.proto);
                        if (pe) FMain->SGStat->Cells[2][FMain->SGStat->RowCount-1] = pe->p_name;
                        else  FMain->SGStat->Cells[2][FMain->SGStat->RowCount-1] = IntToStr(ip.proto);
                        if (ip.proto == 17)
                        {
                                memcpy(&udp,&buf[(ip.ver_len&0x0f) * 4  ],sizeof(udp));
                                udp.sender = ntohs(udp.sender);
                                udp.receiver = ntohs(udp.receiver);
                                se = getservbyport(htons(udp.sender),"udp");
                                if (se) FMain->SGStat->Cells[3][FMain->SGStat->RowCount-1] = IntToStr((USHORT )udp.sender) + '('+se->s_name + ')';
                                else FMain->SGStat->Cells[3][FMain->SGStat->RowCount-1] = IntToStr((USHORT )udp.sender);
                                se = getservbyport(htons(udp.receiver),"udp");
                                if (se) FMain->SGStat->Cells[4][FMain->SGStat->RowCount-1] = IntToStr((USHORT )udp.receiver) + '('+se->s_name + ')';
                                else FMain->SGStat->Cells[4][FMain->SGStat->RowCount-1] = IntToStr((USHORT )udp.receiver);
                        }
                        if (ip.proto == 6)
                        {
                                memcpy(&tcp,&buf[(ip.ver_len&0x0f) * 4 ],sizeof(tcp));
                                tcp.sender = ntohs(tcp.sender);
                                tcp.receiver = ntohs(tcp.receiver);
                                se = getservbyport(htons(tcp.sender),"tcp");
                                if (se) FMain->SGStat->Cells[3][FMain->SGStat->RowCount-1] = IntToStr((USHORT )tcp.sender) + '('+se->s_name + ')';
                                else FMain->SGStat->Cells[3][FMain->SGStat->RowCount-1] = IntToStr((USHORT )tcp.sender);
                                se = getservbyport(htons(tcp.receiver),"tcp");
                                if (se) FMain->SGStat->Cells[4][FMain->SGStat->RowCount-1] = IntToStr((USHORT )tcp.receiver) + '('+se->s_name + ')';
                                else FMain->SGStat->Cells[4][FMain->SGStat->RowCount-1] = IntToStr((USHORT )tcp.receiver);
                        }

                        FMain->SGStat->RowCount = FMain->SGStat->RowCount + 1;
                        FMain->SGStat->RowHeights[FMain->SGStat->RowCount-1] = 20;
                        for (int i = 0;i<=5;i++) FMain->SGStat->Cells[i][FMain->SGStat->RowCount-1] = "";
                        if (Terminated)
                        {
                                //DoOnTerminate(sock);
                                break;
                        }

                       /*
                        if ((index_grid = FindInGrid(inet_ntoa(saddr.sin_addr)))<0)

                        {
                                index_grid = FMain->SGStat->RowCount - 1;
                                FMain->SGStat->RowCount = FMain->SGStat->RowCount + 1;
                                FMain->SGStat->RowHeights[FMain->SGStat->RowCount-1] = 20;
                                FMain->SGStat->Cells[0][index_grid] = inet_ntoa(saddr.sin_addr);
                        }
                        FMain->SGStat->Cells[1][index_grid] = IntToStr(count[index_ar]);
                        FMain->SGStat->Cells[2][index_grid] = IntToStr(lenght[index_ar]);

                        if (cnt>MAX_ETH_FRAME_SIZE)
                        {
                                FMain->RichEdit1->Lines->Add(" "+(AnsiString)inet_ntoa(saddr.sin_addr) +"    "+IntToStr (cnt));
                        };
                        */
                }
        }

        closesocket(sock);



}

void TSniffThrd::DoOnTerminate(SOCKET sock)
{
        FMain->TBStart->Enabled = true;
        FMain->TBStop->Enabled = false;
        closesocket(sock);
}

void TSniffThrd::SetFilter (ULONG Src, ULONG Dst, int Proto,int sPort,int dPort)
{
        if (Src) sAddr = Src; else sAddr = 0;
        if (Dst) dAddr = Dst; else dAddr = 0;
        if (Proto) Protocol = Proto; else Protocol = 0;
        if (sPort) SrcPort = sPort; else SrcPort = 0;
        if (dPort) DstPort = dPort; else DstPort = 0;
}


bool TSniffThrd::CheckFilter (byte *buff)
{
        ip_hdr ip;
        udp_hdr udp;
        tcp_hdr tcp;

        memcpy (&ip,buff,sizeof(ip));
        if (sAddr)
        {
                if (ip.sender!=sAddr) return false;
        }

        if (dAddr)
        {
                if (ip.receiver!=dAddr) return false;
        }

        if (Protocol)
        {
                if (ip.proto != Protocol) return false;
        }

        if (DstPort)
        {

                if (ip.proto == 6)
                {
                        memcpy(&tcp,&buff[(ip.ver_len&0x0f) * 4],sizeof(tcp));
                        tcp.receiver = ntohs(tcp.receiver);
                        if (tcp.receiver != DstPort) return false;
                }
                else if (ip.proto == 17)
                {
                        memcpy(&udp,&buff[(ip.ver_len&0x0f) * 4 ],sizeof(udp));
                        udp.receiver = ntohs(udp.receiver);
                        if (udp.receiver != DstPort) return false;
                }

        }

        if (SrcPort)
        {

                if (ip.proto == 6)
                {
                        memcpy(&tcp,&buff[(ip.ver_len&0x0f) * 4 ],sizeof(tcp));
                        tcp.sender = ntohs(tcp.sender);
                        if (tcp.sender != SrcPort) return false;
                      //  if (tcp.receiver != DstPort) return false;
                }
                else if (ip.proto == 17)
                {
                        memcpy(&udp,&buff[(ip.ver_len&0x0f) * 4],sizeof(udp));
                        udp.sender = ntohs(udp.sender);
                        if (udp.sender != SrcPort) return false;
                       // if (udp.receiver != DstPort) return false;
                }

        }

        return true;

}


//---------------------------------------------------------------------------
