//---------------------------------------------------------------------------

#ifndef UMainH
#define UMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Grids.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>



#include "__packet.h"
#include "ipifcons.h"
#include "iptypes.h"
#include <ImgList.hpp>


#define MAX_PACKET_SIZE    0x10000
#define MAX_ETH_FRAME_SIZE 1514
#define SIO_RCVALL         0x98000001
#define AddrArSize         100
#define IPTOSOPT           3
#define MAX_ICMP_PACKET       1024      // Max ICMP packet size

//---------------------------------------------------------------------------
class TFMain : public TForm
{
__published:	// IDE-managed Components
        TStringGrid *SGStat;
        TToolBar *ToolBar1;
        TSplitter *Splitter1;
        TImageList *ImageList1;
        TToolButton *TBAdaptCase;
        TToolButton *ToolButton2;
        TToolButton *TBFilter;
        TToolButton *TBStart;
        TToolButton *ToolButton4;
        TToolButton *TBStop;
        TToolButton *ToolButton3;
        TToolButton *TBClear;
        TToolButton *ToolButton6;
        TToolButton *TBExit;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall TBAdaptCaseClick(TObject *Sender);
        void __fastcall TBFilterClick(TObject *Sender);
        void __fastcall TBStartClick(TObject *Sender);
        void __fastcall TBStopClick(TObject *Sender);
        void __fastcall TBClearClick(TObject *Sender);
        void __fastcall TBExitClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TFMain(TComponent* Owner);
};



//void FreeGlobals();
//---------------------------------------------------------------------------
extern PACKAGE TFMain *FMain;
//---------------------------------------------------------------------------
#endif
